/* * * * * * * * * * * * * * * *
 * Auto ovládané cez internet
 * Java klient na UDP komunikáciu
 *
 * Stredoškolská Odborná Činnosť
 *
 * Štefan Ciberaj, 2013/2014
 * SOŠ Hviezdoslavova 5, Rožňava
 *
 * Licencia: Voľný softvér, Open-Source GNU GPL v3+
 * Všeobecná verejná licencia. Program je dovolené voľne šíriť a upravovať.
 * Upravený program / časť programu môže ktokoľvek využiť ako na osobné,
 * tak aj komerčné účely, ale nemôže ho vydať s vlastným copyrightom,
 * ktorý nie je kompatibilný s GNU GPL v3+.
 * gnu.org/licenses/gpl-faq.html
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Neoficiálna G4P knižnica pre grafické rozhranie
import g4p_controls.*;

// Neoficiálna UDP sieťová knižnica
import hypermedia.net.*;

// Oficiálna TCP sieťová knižnica
import processing.net.*;
//import java.net.InetAddress;

UDP udp; //objekt pre UDP spojenie

boolean connected=false; //stav pripojenia na riadenie vozidla
boolean cam_connected=false; //stav pripojenia na riadenie kamery

int run = 0;

PImage bg;

//aktualne stlaceny znak
char cam      = ' ';
int cam_i     = 0; //index nastaveny spolu so znakom v premennej cam

char motor    = ' ';
char riadenie = ' ';
char trubenie = ' ';

//predch. znak aby pouzivatel mohol stlacit dalsi znak bez pustenia predchadzajuceho
char motor_last    = ' ';
char riadenie_last = ' ';
char trubenie_last = ' ';

//konstantne premenne urcujuce znak posielany po pusteni klavesy
char MOTOR_STOP     = 'x';
char RIADENIE_STRED = 'r';
char TRUBENIE_STOP  = 'z';

//Znak na trubenie
char trubenie_znaky[]=
{
  't','z'
};

//Zoznam znakov určených na riadenie pohonu vozidla
char motor_znaky[]=
{
  'q','w','e','s','y','x','c'
};

//Zoznam znakov určených na otáčanie predných kolies
char riadenie_znaky[]=
{
  'a','d','r','f','g'
};

//Klávesy, ktorými sa ovláda otáčanie kamery
char cam_znaky[]=
{
  '8','2','6','4','9','7','3','1','0','-','+'
};

//Hodnoty posielané do kamery (index súvisí s cam_znaky[])
String cam_znaky_web_value[]=
{
  "1","2","3","4","5","6","7","8","9","10","11"
};

//Prepínanie jazykov
int SLOVAK   = 0;
int ENGLISH  = 1;
int language = 0;

public void setup(){
  //frame.removeNotify();
  //frame.setUndecorated(true);
  //frame.addNotify();
  size(630, 225, JAVA2D);
  bg = loadImage("background.png");
  createGUI();
  customGUI();
  // Place your setup code here
  // Kod pisat sem, zaciatok funkcie setup je automaticky generovany
  udp = new UDP(this); //inicializacia pre UDP objekt
}

public void draw(){
  background(bg);
  
  //Posielat znaky z klavesnice ak je pripojenie zapnute
  //V pripade, ze nie je stlacena klavesa, poslat STOP/STRED hodnotu
  if(connected==true)
  {
    if(!focused)
    {
      motor=MOTOR_STOP;
      riadenie=RIADENIE_STRED;
      trubenie=TRUBENIE_STOP;
    }
    run++;
    if(run>2)
    {
      http_udp_cmd();
      run=0;
    }
  }
}

// Use this method to add additional statements
// to customise the GUI controls
public void customGUI(){

}

//Funkcia na ovládanie kamery
void http_tcp_cam(String value, boolean start)
{
  String get = "GET /media/?action=cmd&code=";
  if(start==true)
  {
    get += "2";
  }
  else
  {
    get += "3";
  }
  get += "&value=";
  get += value;
  get += "&user=";
  get += textfield_cam_meno.getText();
  get += "&pwd=";
  get += textfield_cam_heslo.getText();
  get += " HTTP/1.0\r\n";
  /* Zvysok nie je potrebny pre spravnu funkcnost:
  get += Host: "; 
  get += textfield_cam.getText();
  get += ":";
  get += textfield_camport.getText();
  get += "\r\n";*/
  
  Client client = new Client(this, textfield_cam.getText(), Integer.parseInt(textfield_camport.getText()));
  client.write(get+"\r\n");
  client.stop();
  
  //Zmena stavu za ucelom informovania pouzivatela o funkcnosti spojenia
  label_cam_stav.setText("Pripojené");
  label_cam_stav.setLocalColorScheme(GCScheme.GREEN_SCHEME);
}

//Funkcia na ovládanie vozidla (pohon a riadenie predných kolies)
void http_udp_cmd()
{
  String cmd = "?p=";
  cmd += textfield_heslo.getText();
  cmd += "&cmd=";
  
  //ak nie je stlacena klavesa pre motor tak ho zastavit
  if(motor==' ')
  {
    cmd += MOTOR_STOP;
    label_vstup.setText("cmd="+MOTOR_STOP);
  }
  else
  {
    cmd += motor;
    label_vstup.setText("cmd="+motor);
  }
  
  //ak nie je stlacena klavesa pre riadenie tak ho otocit na stred
  if(riadenie==' ')
  {
    cmd += RIADENIE_STRED;
    label_vstup.setText(label_vstup.getText()+RIADENIE_STRED);
  }
  else
  {
    cmd += riadenie;
    label_vstup.setText(label_vstup.getText()+riadenie);
  }
  
  //ak nie je stlacena klavesa pre riadenie tak vypnut trubenie
  if(trubenie==' ')
  {
    cmd += TRUBENIE_STOP;
    label_vstup.setText(label_vstup.getText()+TRUBENIE_STOP);
  }
  else
  {
    cmd += trubenie;
    label_vstup.setText(label_vstup.getText()+trubenie);
  }
  
  //poslat cely zlozeny prikaz do vozidla
  udp.send(cmd+".",textfield_ip.getText(),Integer.parseInt(textfield_port.getText()));
}

//Funkcia na nastavenie novej hodnoty latencie
void http_lat()
{
  label_vstup.setText("lat="+textfield_lat.getText());
  udp.send("?p="+textfield_heslo.getText()+"&lat="+textfield_lat.getText()+".",textfield_ip.getText(),Integer.parseInt(textfield_port.getText()));
}

//Funkcia na nastavenie nového znaku pre pohon vozidla
void motor_set(char c)
{
  //ak este nie su stlacene 2 klavesy pre motor
  if(motor_last==' ')
  {
    //ak zatial nie je ziaden pohyb, spustit prikaz priamo
    if(motor==' ')
    {
      motor=c;
    }
    //ak sa uz motor pohybuje, pamatat si dalsi prikaz
    else if(motor!=c)
    {
      motor_last=motor;
      motor=c;
    }
  }
}

//Funkcia na nastavenie nového znaku na otáčanie predných kolies
void riadenie_set(char c)
{
  //ak este nie su stlacene 2 klavesy pre riadenie
  if(riadenie_last==' ')
  {
    //ak zatial nie je ziaden pohyb, spustit prikaz priamo
    if(riadenie==' ')
    {
      riadenie=c;
    }
    //ak sa uz riadenie pohybuje, pamatat si dalsi prikaz
    else if(riadenie!=c)
    {
      riadenie_last=riadenie;
      riadenie=c;
    }
  }
}

//Funkcia na nastavenie nového znaku pre pohon vozidla
void trubenie_set(char c)
{
  //ak este nie su stlacene 2 klavesy pre motor
  if(trubenie_last==' ')
  {
    //ak zatial nie je ziaden pohyb, spustit prikaz priamo
    if(trubenie==' ')
    {
      trubenie=c;
    }
    //ak sa uz motor pohybuje, pamatat si dalsi prikaz
    else if(trubenie!=c)
    {
      trubenie_last=trubenie;
      trubenie=c;
    }
  }
}

//Event vykonaný po stlačení klávesy
void keyPressed()
{
  for(int i=0;i<motor_znaky.length;i++)
  {
    if(key==motor_znaky[i])
    {
      motor_set(key);
    }
  }
  
  for(int i=0;i<riadenie_znaky.length;i++)
  {
    if(key==riadenie_znaky[i])
    {
      riadenie_set(key);
    }
  }
  
  for(int i=0;i<trubenie_znaky.length;i++)
  {
    if(key==trubenie_znaky[i])
    {
      trubenie_set(key);
    }
  }
  
  for(int i=0;i<cam_znaky.length;i++)
  {
    if(cam_connected && key==cam_znaky[i] && key!=cam)
    {
      http_tcp_cam(cam_znaky_web_value[cam_i],false);
      cam=key;
      cam_i=i;
      http_tcp_cam(cam_znaky_web_value[cam_i],true);
      label_cam_vstup.setText(cam_znaky[cam_i]+" start");
    }
  }
}

//Event vykonaný po pustení klávesy
void keyReleased()
{
  if(motor==key)
  {
    motor=motor_last;
    motor_last=' ';
  }
  
  if(motor_last==key)
  {
    motor_last=' ';
  }
  
  if(riadenie==key)
  {
    riadenie=riadenie_last;
    riadenie_last=' ';
  }
  
  if(riadenie_last==key)
  {
    riadenie_last=' ';
  }
  
  if(trubenie==key)
  {
    trubenie=trubenie_last;
    trubenie_last=' ';
  }
  
  if(trubenie_last==key)
  {
    trubenie_last=' ';
  }
  
  if(cam_connected && cam==key)
  {
    http_tcp_cam(cam_znaky_web_value[cam_i],false);
    label_cam_vstup.setText(cam_znaky[cam_i]+" stop");
    cam=' ';
  }
}
